#pragma once
#include "SimpleWindow.h"

class fkut_CubicModel : public fk_Model {
private:
	fk_IndexFaceSet	shape;

protected:
	void makeCircle(int div, double r);
	void makeBlock(double w, double h, double d);
	void makeSphere(int div, double r);
	void makePrism(int div, double rt, double rb, double h);
	void makeCone(int div, double r, double h);

public:
	fkut_CubicModel(void);
	~fkut_CubicModel(void);
};

class fkut_BlockModel : public fkut_CubicModel {
public:
	void create(double width, double height, double depth)
	{
		makeBlock(width, height, depth);
	};
};

class fkut_SphereModel : public fkut_CubicModel {
public:
	void create(int div, double radius)
	{
		makeSphere(div, radius);
	}
};

class fkut_PrismModel : public fkut_CubicModel {
public:
	void create(int div, double top, double bottom, double height)
	{
		makePrism(div, top, bottom, height);
	}
};

class fkut_ConeModel : public fkut_CubicModel {
public:
	void create(int div, double radius, double height)
	{
		makeCone(div, radius, height);
	}
};
