#pragma once
#include <FK/FK.h>
#include "FrameController.h"
#include "GuideObject.h"
#include "TrackBall.h"

class fkut_SimpleWindow {
private:
	friend class fkut_CubicModel;

	Fl_Window	*mainWin;
	fk_Window	*drawWin;

	fkut_FrameController	fps_admin;
	fkut_GuideObject		guide;
	fk_TrackBall			*tb;

	fk_Scene	scene;
	fk_Light	lightShape;
	fk_Model	camera, light;

	int		fps;
	bool	tbFlag;

public:
	fkut_SimpleWindow(void);
	~fkut_SimpleWindow(void);

	void setSize(int w, int h);
	void setBGColor(double r, double g, double b);
	void setFPS(int fps);
	void setTrackBallMode(bool mode);

	void showGuide(fkut_GuideMode mode = FKUT_AXIS_X | FKUT_AXIS_Y | FKUT_AXIS_Z | FKUT_GRID_XZ);
	void hideGuide(void);

	void setCameraPos(double x, double y, double z);
	void setCameraFocus(double x, double y, double z);

	void entry(fk_Model &model);
	void remove(fk_Model &model);

	void open(void);
	void close(void);

	bool update(void);
};
